﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace DataReader_TypedAccessors
{
    class Program
    {
        static void Main(string[] args)
        {
            int NumeroInteracoes = 8000;

            int EmployeeID;
            string LastName;
            string FirstName = null;
            string city;

            int tempoInicio = 0;
            int tempoDecorrido;

            string sqlConnectString = @"Data Source=.\SQLEXPRESS;Initial Catalog=Northwind;Integrated Security=SSPI;";
            string sqlSelect = "SELECT EmployeeID, LastName, FirstName, City FROM Employees";

            Console.WriteLine("---Tipo de Acesso ao DataReader , {0} No. Iterações ---\n", NumeroInteracoes);

            SqlConnection connection = new SqlConnection(sqlConnectString);
            // Cria o comando e abre a conexão
            SqlCommand command = new SqlCommand(sqlSelect, connection);
            connection.Open();

            tempoDecorrido = 0;
            for (int i = 0; i < NumeroInteracoes; i++)
            {
                // Cria o DataReader e retorna todos os campos para
                // cada registro usando o acessor tipado com a coluna ordinal
                using (SqlDataReader dr = command.ExecuteReader())
                {
                    tempoInicio = Environment.TickCount;
                    while (dr.Read())
                    {
                        EmployeeID = dr.GetInt32(0);
                        LastName = dr.GetString(1);
                        FirstName = dr.IsDBNull(2) ? null : dr.GetString(2);
                        city = dr.GetString(3);
                    }
                    tempoDecorrido += Environment.TickCount - tempoInicio;
                }
            }

            Console.WriteLine("Acessor Tipado: Tempo = {0} ",tempoDecorrido);

            tempoDecorrido = 0;
            for (int i = 0; i < NumeroInteracoes; i++)
            {
                // Cria o DataReader e retorna os campos para 
                // cada registro usando a coluna ordinal
                using (SqlDataReader dr = command.ExecuteReader())
                {
                    tempoInicio = Environment.TickCount;
                    while (dr.Read())
                    {
                        EmployeeID = Convert.ToInt32(dr[0]);
                        LastName = Convert.ToString(dr[1]);
                        FirstName = Convert.ToString(dr[2]);
                        city = Convert.ToString(dr[3]);
                    }

                    tempoDecorrido += Environment.TickCount - tempoInicio;
                }
            }
            Console.WriteLine("Coluna Ordinal: Tempo = {0}", tempoDecorrido);

            tempoDecorrido = 0;
            for (int i = 0; i < NumeroInteracoes; i++)
            {
                // Cria o DataReader e retorna os campos para 
                // cada registro usando o nome do campo da coluna
                using (SqlDataReader dr = command.ExecuteReader())
                {
                    tempoInicio = Environment.TickCount;
                    while (dr.Read())
                    {
                        EmployeeID = Convert.ToInt32(dr["EmployeeID"]);
                        LastName = Convert.ToString(dr["LastName"]);
                        FirstName = Convert.ToString(dr["FirstName"]);
                        city = Convert.ToString(dr["city"]);
                    }

                    tempoDecorrido += Environment.TickCount - tempoInicio;
                }
            }
            Console.WriteLine("Nome da Coluna: Tempo = {0}", tempoDecorrido);
            Console.WriteLine("\\nPressione algo para continuar.");
            Console.ReadKey();
        }
    }
}
